Index: branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmRequestPrint.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmRequestPrint.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmRequestPrint.cs	(revision 51)
@@ -0,0 +1,1346 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using System.Threading.Tasks;
+
+using ProcessManagement.Common;
+using ProcessManagement.DB.IOAccess;
+using ProcessManagement.DataModel;
+using ProcessManagement.Forms.CustomControls;
+using ProcessManagement.Forms.ControlsAction;
+
+namespace ProcessManagement.Forms.SubForms
+{
+    public partial class FrmRequestPrint : Form
+    {
+        #region ログ使用定義
+        //log4netログを使用する
+        private static readonly log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
+        #endregion
+
+        #region 定数
+        private enum Dispcount
+        {
+            ExeCuteDate = 0,
+            ProgressStatusA,
+            ProgressStatusB,
+            radioButtonA1,
+            radioButtonA2,
+            radioButtonB1,
+            radioButtonB2,
+            radioButtonC1,
+            radioButtonC2,
+        }
+
+        /// <summary>
+        /// Excelテンプレートファイル名
+        /// </summary>
+        private static string s_ExcelRequestSheetFileName = @"\RequestSheet.xlsx";
+
+        /// <summary>
+        /// デスクトップフォルダ名
+        /// </summary>
+        private static string s_ExecCurrentDirName = System.Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory);
+
+        /// <summary>
+        /// シート名称カウント
+        /// </summary>
+        enum enumSheetName
+        {
+            Cover = 0,
+            Detail,
+        }
+
+        /// <summary>
+        /// Excel シート名称
+        /// </summary>
+        private static readonly Dictionary<enumSheetName,string> s_DicSheetName = new Dictionary<enumSheetName, string>()
+        {
+            { enumSheetName.Cover, "請求書（表紙）" },
+            { enumSheetName.Detail, "請求書（内訳）" },
+        };
+        #endregion
+
+        #region 変数
+        /// <summary>
+        /// 終了状態フラグ
+        /// </summary>
+        private DialogResult m_EndButton = DialogResult.None;
+
+        /// <summary>
+        /// 工事番号
+        /// </summary>
+        private int m_ConstructionCode = 0;
+
+        /// <summary>
+        /// 請求番号
+        /// </summary>
+        private int m_RequestNo = 0;
+
+        /// <summary>
+        /// 実行時日付
+        /// </summary>
+        private DateTime m_ExcuteDate = DateTime.Now;
+        
+        /// <summary>
+        /// 実行進捗状態
+        /// </summary>
+        private int m_ProgressStatus = 9;
+
+        /// <summary>
+        /// 日付印刷
+        /// </summary>
+        private bool m_bDatePrintFlg = true;
+        
+        /// <summary>
+        /// コンロールオブジェクト
+        /// </summary>
+        private Control[] m_dispControl = new Control[9];
+
+        /// <summary>
+        /// 工事基本情報
+        /// </summary>
+        private ConstructionBaseInfo m_ConstructionBaseInfo = new ConstructionBaseInfo();
+
+        /// <summary>
+        /// 工事基本情報明細
+        /// </summary>
+        private Dictionary<int, Dictionary<int, string>> m_DicConstructionBaseInfoDetail = new Dictionary<int, Dictionary<int, string>>();
+
+        /// <summary>
+        /// 増減工事情報
+        /// </summary>
+        private List<int> m_LstConstructionLink = new List<int>();
+
+        /// <summary>
+        /// 請求データ
+        /// </summary>
+        private RequestData m_RequestData = new RequestData();
+
+        /// <summary>
+        /// 請求合計データ
+        /// </summary>
+        private List<RequestTotalData> m_LstRequestTotalData = new List<RequestTotalData>();
+
+        /// <summary>
+        /// ツールチップ
+        /// </summary>
+        private ToolTip ToolTip1 = new ToolTip();
+
+        /// <summary>
+        /// Excel印刷クラスオブジェクト
+        /// </summary>
+        private UsedExcel m_UsedExcel = null;
+
+        /// <summary>
+        /// 保存時Excelパス
+        /// </summary>
+        private string m_SelectSaveExcel = "";
+
+        /// <summary>
+        /// 印刷選択請求書受付番号インデックス
+        /// </summary>
+        private int m_SelectOrderIndex = 0;
+
+        // *-----* 共通処理設定 *-----*
+        /// <summary>
+        /// サブフォームフラグ
+        /// </summary>
+        private bool m_SubForm = false;
+        /// <summary>
+        /// 呼出元終了フラグ
+        /// </summary>
+        private bool m_ParentEnd = false;
+        // *-----* 共通処理設定 *-----*
+
+        #endregion
+
+        #region プロパティ
+        /// <summary>
+        /// 工事番号
+        /// </summary>
+        public int ConstructionCode
+        {
+            get { return m_ConstructionCode; }
+            set { m_ConstructionCode = value; }
+        }
+
+        public int RequestNo
+        {
+            get { return m_RequestNo; }
+            set { m_RequestNo = value; }
+        }
+
+        /// <summary>
+        /// 実行時時間
+        /// </summary>
+        public DateTime ExcuteDate
+        {
+            get { return m_ExcuteDate; }
+            set { m_ExcuteDate = value; }
+        }
+        /// <summary>
+        /// 終了ボタン状態
+        /// </summary>
+        public DialogResult EndButton
+        {
+            get { return m_EndButton; }
+        }
+        /// <summary>
+        /// 日付印刷フラグ
+        /// </summary>
+        public bool DatePrintFlg
+        {
+            get { return m_bDatePrintFlg; }
+            set { m_bDatePrintFlg = value; }
+        }
+
+        // *-----* 共通処理設定 *-----*
+        /// <summary>
+        /// サブフォームフラグ
+        /// </summary>
+        public bool SubForm
+        {
+            get { return m_SubForm; }
+            set { m_SubForm = value; }
+        }
+        /// <summary>
+        /// 呼出元終了フラグ
+        /// </summary>
+        public bool ParentEnd
+        {
+            get { return m_ParentEnd; }
+            set { m_ParentEnd = value; }
+        }
+
+        // *-----* 共通処理設定 *-----*        
+        
+        #endregion
+
+        #region ×ボタン
+        /// <summary>
+        /// ×ボタン押下処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void FrmStatusAndDate_FormClosed(object sender, FormClosedEventArgs e)
+        {
+            if (m_EndButton == DialogResult.None) m_EndButton = DialogResult.Cancel;
+        }
+        #endregion
+
+        #region コンストラクタ
+        /// <summary>
+        /// フォーム初期化
+        /// </summary>
+        public FrmRequestPrint()
+        {
+            InitializeComponent();
+        }
+        #endregion
+
+        #region フォームロード
+        /// <summary>
+        /// フォームロード
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void FrmCostStructureDiag_Load(object sender, EventArgs e)
+        {
+            // フォームサイズ固定
+            this.MaximizedBounds = new Rectangle(this.Left, this.Top, this.Width, this.Height);
+         
+            // コントロールのセット
+            SetDisplayObject();
+            
+            // 初期表示
+            InitDataLoad();
+        }
+        #endregion
+
+        #region キャンセルボタン
+        /// <summary>
+        /// キャンセルボタン追加
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnCancel_Click(object sender, EventArgs e)
+        {
+            m_EndButton = DialogResult.Cancel;
+            this.Close();
+        }
+        #endregion
+
+        #region 印刷のみボタン
+        /// <summary>
+        /// 印刷のみボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private async void btnExecProc1_Click(object sender, EventArgs e)
+        {
+            // 状態確認
+            if (!StatusChange()) return;
+
+            // 日付印刷をしない
+            if (radioButton3.Checked) m_bDatePrintFlg = false;
+
+            // 選択日付取得
+            m_ExcuteDate = dateTimePicker1.Value;
+
+            // 工事基本情報を更新する
+            UpdateConstructionBaseInfo();
+
+            // 非同期で印刷処理を実行する
+            m_SelectOrderIndex = cmbOrderNo.SelectedIndex;
+            await Task.Run(() =>
+            {
+                // 印刷処理
+                PrintMain(true);
+            });
+
+            m_EndButton = DialogResult.Yes;
+            this.Close();
+        }
+        #endregion
+
+        #region 保存のみボタン
+        /// <summary>
+        /// 保存のみボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private async void btnExecProc2_Click(object sender, EventArgs e)
+        {
+            // 保存先指定ダイアログの表示
+            FrmSaveFilePath frm = new FrmSaveFilePath();
+            frm.SaveType = (int)CommonDefine.SaveFileType.ExcelFile;
+            frm.ShowDialog();
+            if (frm.EndButton == DialogResult.Cancel)
+            {
+                return;
+            }
+            m_SelectSaveExcel = frm.SelectPath;
+
+            // 状態確認
+            if (!StatusChange()) return;
+
+            // 日付印刷をしない
+            if (radioButton3.Checked) m_bDatePrintFlg = false;
+            
+            // 選択日付取得
+            m_ExcuteDate = dateTimePicker1.Value;
+
+            // 工事基本情報を更新する
+            UpdateConstructionBaseInfo();
+
+            // 非同期で印刷処理を実行する
+            m_SelectOrderIndex = cmbOrderNo.SelectedIndex;
+            await Task.Run(() =>
+            {
+                // 印刷処理
+                PrintMain(false);
+            });
+
+            m_EndButton = DialogResult.No;
+            this.Close();
+        }
+        #endregion
+
+        #region 提出時ラジオボタンチェック
+        /// <summary>
+        /// 提出日印字ラジオボタン
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void radioButton3_CheckedChanged(object sender, EventArgs e)
+        {
+            if (radioButton3.Checked)
+            {
+                dateTimePicker1.Visible = false;
+            }
+            else
+            {
+                dateTimePicker1.Visible = true;
+            }
+        }
+        #endregion
+
+        #region 工事進捗ラジオボタン
+        /// <summary>
+        /// 工事進捗ラジオボタンの変更
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void radioButton1_CheckedChanged(object sender, EventArgs e)
+        {
+            // 工事進捗変更
+            if (radioButton1.Checked)
+            {   // 変更する
+                m_dispControl[(int)Dispcount.ProgressStatusB].Text = CommonDefine.ProjectsStatus[m_ProgressStatus];
+            }
+            else
+            {   // 変更しない
+                m_dispControl[(int)Dispcount.ProgressStatusB].Text = CommonDefine.ProjectsStatus[m_ConstructionBaseInfo.ConstructionStatusFlg];
+            }
+        }
+        #endregion
+
+        #region オブジェクトコントロールセット
+        /// <summary>
+        /// 表示オブジェクトの取得
+        /// </summary>
+        private void SetDisplayObject()
+        {
+            m_dispControl[(int)Dispcount.ExeCuteDate] = dateTimePicker1;
+            m_dispControl[(int)Dispcount.ProgressStatusA] = lblProgressNameA;
+            m_dispControl[(int)Dispcount.ProgressStatusB] = lblProgressNameB;
+            m_dispControl[(int)Dispcount.radioButtonA1] = radioButton1;
+            m_dispControl[(int)Dispcount.radioButtonA2] = radioButton2;
+            m_dispControl[(int)Dispcount.radioButtonB1] = radioButton4;
+            m_dispControl[(int)Dispcount.radioButtonB2] = radioButton3;
+        }
+        #endregion
+
+        #region ステータスチェック
+        /// <summary>
+        /// 工事案件の進捗状態変更の確認
+        /// </summary>
+        /// <returns></returns>
+        private bool StatusChange()
+        {
+            try
+            {
+                if (!lblProgressNameA.Text.Equals(lblProgressNameB.Text))
+                {
+                    if (MessageBox.Show("工事案件の進捗状態が変わります、よろしいですか？",
+                                        "進捗状態変更確認",
+                                        MessageBoxButtons.OKCancel, 
+                                        MessageBoxIcon.Question) == DialogResult.Cancel)
+                    {
+                        return false;
+                    }
+                }
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        
+        #endregion
+
+        #region 表示関連
+        /// <summary>
+        /// 初期表示処理
+        /// </summary>
+        private void InitDataLoad()
+        {
+            try
+            {
+                if (!DisplayData())
+                {
+                    m_EndButton = DialogResult.Cancel;
+                    this.Close();
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region データ表示処理
+        /// <summary>
+        /// データ表示
+        /// </summary>
+        /// <returns></returns>
+        private bool DisplayData()
+        {
+            var lstReqTotalData = new List<RequestTotalData>();
+
+            try
+            {
+                bool bRet = true;
+
+                // 工事基本情報を取得
+                if (!GetConstructionBaseInfo(m_ConstructionCode, ref m_ConstructionBaseInfo))
+                {
+                    return false;
+                }
+
+                // 増減工事情報を取得
+                if (!GetConstructionLink(m_ConstructionCode, ref m_LstConstructionLink))
+                {
+                    return false;
+                }
+
+                List<int> lstConstCodes = new List<int>();
+                lstConstCodes.Add(m_ConstructionCode);
+                lstConstCodes.AddRange(m_LstConstructionLink);
+
+                // 工事基本情報明細を取得
+                if (!GetConstructionBaseInfoDetail(lstConstCodes, ref m_DicConstructionBaseInfoDetail))
+                {
+                    return false;
+                }
+
+                // 請求データを取得
+                if (!GetRequestData(m_ConstructionCode, ref m_RequestData))
+                {
+                    return false;
+                }
+
+                // 請求合計データを取得
+                if (!GetRequestTotalData(m_RequestNo, ref m_LstRequestTotalData))
+                {
+                    return false;
+                }
+
+                // 作成対象のコンボボックスリストを初期化
+                cmbOrderNo.Items.Clear();
+                foreach (var reqTotalData in m_LstRequestTotalData)
+                {
+                    // 請求回数分
+                    cmbOrderNo.Items.Add(string.Format("{0}回目", reqTotalData.OrderNo));
+                }
+                cmbOrderNo.SelectedIndex = 0;
+
+                // 初期時間セット
+                dateTimePicker1.Value = m_ExcuteDate;
+
+                // ----- 状態を工事基本情報より取る
+                // 現在進捗状態
+                m_dispControl[(int)Dispcount.ProgressStatusA].Text = CommonDefine.ProjectsStatus[m_ConstructionBaseInfo.ConstructionStatusFlg];
+
+                // 実行後進捗状態
+                if (m_ConstructionBaseInfo.ConstructionStatusFlg == 8)
+                {
+                    // 現在の進捗状態が施工完了の場合
+                    radioButton1.Checked = true;
+                    m_dispControl[(int)Dispcount.ProgressStatusB].Text = CommonDefine.ProjectsStatus[m_ProgressStatus];
+                }
+                else
+                {
+                    // 施工完了以外の場合
+                    radioButton2.Checked = true;
+                    radioButton1.Enabled = false;
+                    m_dispControl[(int)Dispcount.ProgressStatusB].Text = m_dispControl[(int)Dispcount.ProgressStatusA].Text;
+                }
+
+                // ----- ToolTipの設定を行う
+                // ToolTipが表示されるまでの時間
+                ToolTip1.InitialDelay = 0;
+                // ToolTipが表示されている時に、別のToolTipを表示するまでの時間
+                ToolTip1.ReshowDelay = 1000;
+                // ToolTipを表示する時間
+                ToolTip1.AutoPopDelay = 10000;
+                // フォームがアクティブでない時はToolTipを表示しない
+                ToolTip1.ShowAlways = false;
+
+                // 文字セット
+                ToolTip1.SetToolTip(dateTimePicker1, "請求日が表示されている日付と違う場合は、変更してください。");
+                ToolTip1.SetToolTip(radioButton4, "請求日を請求書へ「印刷する」場合は、こちらを選択してください。");
+                ToolTip1.SetToolTip(radioButton3, "請求日を請求書へ「印刷せずに空白」で印刷する場合は、こちらを選択してください。");
+
+                ToolTip1.SetToolTip(radioButton1, "工事進捗状態を変更して次の処理へ進む場合は、こちらを選択してください。");
+                ToolTip1.SetToolTip(radioButton2, "工事進捗進捗を現在の状態から変更しない場合は、こちらを選択してください。");
+                
+                return bRet;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 工事データ更新
+        /// <summary>
+        /// 工事基本情報を更新する
+        /// </summary>
+        /// <returns></returns>
+        private bool UpdateConstructionBaseInfo()
+        {
+            var lstReqTotalData = new List<RequestTotalData>();
+            IOConstructionBaseInfo cbDB = new IOConstructionBaseInfo();
+            try
+            {
+                bool bUpdate = false;
+
+                string strSQL = cbDB.CreatePrimarykeyString(m_RequestNo);
+                ConstructionBaseInfo DataRec = new ConstructionBaseInfo();
+                if (!cbDB.SelectAction(strSQL, ref DataRec)) return false;
+                
+                // 進捗状態
+                if (radioButton1.Checked)
+                {
+                    DataRec.ConstructionStatusFlg = m_ProgressStatus;
+                    bUpdate = true;
+                }
+
+                // 変化なしは処理しない
+                if (!bUpdate) return true;
+
+                if (!cbDB.UpdateAction(strSQL, DataRec)) return false;
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                cbDB.close(); cbDB = null;
+            }
+
+            return true;
+        }
+
+        #endregion
+
+        #region DBアクセス処理
+        #region 請求データ取得
+        /// <summary>
+        /// 請求データ取得
+        /// </summary>
+        /// <param name="constCode">本工事番号</param>
+        /// <param name="data"></param>
+        /// <returns></returns>
+        private bool GetRequestData(int constCode, ref RequestData data)
+        {
+            var cbDB = new IORequestData();
+            try
+            {
+                // 請求データ取得クラス領域
+                var wrk = new List<RequestData>();
+
+                // 請求データ取得SQL
+                string strSQL = cbDB.CreateSubkeyString(constCode);
+
+                // 請求データ取得
+                if (!cbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                if (wrk.Count != 1) return false;
+
+                data = wrk[0];
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                cbDB.close(); cbDB = null;
+            }
+
+            return true;
+        }
+        #endregion
+
+        #region 請求書合計データ取得
+        /// <summary>
+        /// 請求書合計データ取得
+        /// </summary>
+        /// <param name="requestNo"></param>
+        /// <param name="datas"></param>
+        /// <returns></returns>
+        private bool GetRequestTotalData(int requestNo, ref List<RequestTotalData> datas)
+        {
+            var cbDB = new IORequestTotalData();
+            try
+            {
+                // 請求書合計データ取得クラス領域
+                var wrk = new List<RequestTotalData>();
+
+                // 請求書合計データ取得SQL
+                string strSQL = cbDB.CreatePrimarykeyString(requestNo);
+
+                // ソート条件追加
+                strSQL += " ORDER BY REQUESTNO, ORDERNO";
+
+                // 請求書合計データ取得
+                if (!cbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                // 請求書合計データ取得クラス領域
+                datas = wrk;
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                cbDB.close(); cbDB = null;
+            }
+            return true;
+        }
+
+        #endregion
+
+        #region 請求明細データ取得
+        /// <summary>
+        /// 請求明細データ取得
+        /// </summary>
+        /// <param name="requestNo"></param>
+        /// <param name="datas"></param>
+        /// <returns></returns>
+        private bool GetRequestDataDetail(int requestNo, ref Dictionary<int, Dictionary<int, RequestDataDetail>> datas)
+        {
+            var cbDB = new IORequestDataDetail();
+            try
+            {
+                // 請求明細データ取得クラス領域
+                var wrk = new List<RequestDataDetail>();
+
+                // 請求明細データ取得SQL
+                string strSQL = cbDB.CreatePrimarykeyString(requestNo);
+
+                // 請求明細データ取得
+                if (!cbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                foreach (var record in wrk)
+                {
+                    if (!datas.ContainsKey(record.ConstructionCode))
+                        datas[record.ConstructionCode] = new Dictionary<int, RequestDataDetail>();
+                    datas[record.ConstructionCode][record.OrderNo] = record;
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                cbDB.close(); cbDB = null;
+            }
+            return true;
+        }
+        #endregion
+
+        #region 工事基本情報取得
+        /// <summary>
+        /// 工事基本情報取得
+        /// </summary>
+        /// <param name="constructionCode"></param>
+        /// <param name="data"></param>
+        /// <returns></returns>
+        private bool GetConstructionBaseInfo(int constructionCode, ref ConstructionBaseInfo data)
+        {
+            var cbDB = new IOConstructionBaseInfo();
+            try
+            {
+                // 工事基本情報取得クラス領域
+                var wrk = new ConstructionBaseInfo();
+
+                // 工事基本情報取得SQL
+                string strSQL = cbDB.CreatePrimarykeyString(constructionCode);
+
+                // 工事基本情報取得
+                if (!cbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                // 工事基本情報取得クラス領域
+                data = wrk;
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                cbDB.close(); cbDB = null;
+            }
+            return true;
+        }
+        #endregion
+
+        #region 工事基本情報明細
+        /// <summary>
+        /// 工事基本情報明細を工事基本情報明細テーブルから工事番号をキーに取得する関数
+        /// </summary>
+        /// <param name="datas"></param>
+        /// <returns></returns>
+        private bool GetConstructionBaseInfoDetail(List<int> lstConstCode, ref Dictionary<int,Dictionary<int,string>> datas)
+        {
+            var sbDB = new IOConstructionBaseInfoDetail();
+            try
+            {
+                // 工事基本情報明細取得クラス領域
+                var wrk = new List<ConstructionBaseInfoDetail>();
+
+                // 工事基本情報明細取得SQL
+                string strSQL = " Where ConstructionCode in ( ";
+                foreach (int constCode in lstConstCode)
+                {
+                    strSQL += string.Format((lstConstCode.IndexOf(constCode) == 0) ? " {0}" : ", {0}", constCode);
+                }
+                strSQL += " )";
+
+                // 工事基本情報明細取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                datas.Clear();
+
+                foreach (var record in wrk)
+                {
+                    if (!datas.ContainsKey(record.ConstructionCode))
+                        datas[record.ConstructionCode] = new Dictionary<int, string>();
+                    datas[record.ConstructionCode][record.DetailNo] = record.DetailString;
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+        }
+        #endregion
+
+        #region 工事増減情報取得
+        /// <summary>
+        /// 工事増減情報取得
+        /// </summary>
+        /// <param name="constructionCode"></param>
+        /// <param name="datas"></param>
+        /// <returns></returns>
+        private bool GetConstructionLink(int constructionCode, ref List<int> datas)
+        {
+            var sbDB = new IOConstructionLink();
+            try
+            {
+                // 工事増減情報取得クラス領域
+                var wrk = new List<ConstructionLink>();
+
+                // 工事増減情報取得SQL
+                string strSQL = sbDB.CreatePrimarykeyString(constructionCode);
+
+                // ソート条件追加
+                strSQL += " ORDER BY FLUCTUATIONCODE";
+
+                // 工事増減情報取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                foreach (var record in wrk)
+                {
+                    datas.Add(record.FluctuationCode);
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+        }
+        #endregion
+
+        #region 工事詳細台帳データ取得
+        /// <summary>
+        /// 工事詳細台帳データ取得
+        /// </summary>
+        /// <param name="constructionCode"></param>
+        /// <param name="data"></param>
+        /// <returns></returns>
+        private bool GetConstructionLedger(int constructionCode, ref ConstructionLedger data)
+        {
+            var sbDB = new IOConstructionLedger();
+            try
+            {
+                // 工事詳細台帳データ取得クラス領域
+                var wrk = new ConstructionLedger();
+
+                // 工事詳細台帳データ取得SQL
+                string strSQL = sbDB.CreatePrimarykeyString(constructionCode);
+
+                // 工事詳細台帳データ取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                data = wrk;
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+        }
+        #endregion
+        #endregion
+
+        #region 印刷メイン
+        /// <summary>
+        /// 印刷メイン
+        /// </summary>
+        /// <param name="bPrint">true:印刷のみ,false:保存のみ</param>
+        public void PrintMain(bool bPrint)
+        {
+            try
+            {
+                // 請求明細データ取得
+                var dicReqDetail = new Dictionary<int, Dictionary<int, RequestDataDetail>>();
+                if (!GetRequestDataDetail(m_RequestNo,ref dicReqDetail))
+                {
+                    return;
+                }
+
+                // 工事詳細台帳データ取得
+                var constLedger = new ConstructionLedger();
+                if (!GetConstructionLedger(m_ConstructionCode, ref constLedger))
+                {
+                    return;
+                }
+
+                // 印刷クラス
+                m_UsedExcel = new UsedExcel();
+
+                // エクセルブックオープン
+                if (!m_UsedExcel.ExcelBookOpen(System.Environment.CurrentDirectory + s_ExcelRequestSheetFileName))
+                {
+                    return;
+                }
+
+                // 表紙印刷
+                CommonDefine.RetunAnswer rtAns = PrintCover();
+                if (rtAns != CommonDefine.RetunAnswer.Answer0)
+                {
+                    return;
+                }
+
+                // 内訳印刷
+                rtAns = PrintDetail(dicReqDetail, constLedger);
+                if (rtAns != CommonDefine.RetunAnswer.Answer0)
+                {
+                    return;
+                }
+
+                if (bPrint)
+                {
+                    // 印刷処理
+                    m_UsedExcel.ExcelSheetPrint();
+                }
+                else
+                {
+                    // 保存処理
+                    SaveExcelFile();
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                // Excel開放
+                if (m_UsedExcel != null)
+                {
+                    m_UsedExcel.ExcelBookClose();
+                }
+                m_UsedExcel = null;
+
+                // ガーベージコレクト
+                GC.Collect();
+            }
+
+        }
+        #endregion
+
+        /// <summary>
+        /// Excelファイル保存処理
+        /// </summary>
+        private void SaveExcelFile()
+        {
+            try
+            {
+                string filePath = @m_SelectSaveExcel;
+
+                // ファイルパスの存在をチェック
+                if (CommonMotions.ChkDirPath(filePath, true))
+                {
+                    // ファイル名を作成
+                    string wrkFile = m_DicConstructionBaseInfoDetail[m_ConstructionCode][(int)ConstructionBaseInfoDetail.DetailDataNo.OrderersName] + "様 請求書";
+
+                    // ファイル名に使用できない文字を取り除く
+                    foreach (var badCh in m_UsedExcel.ExcelBadCharcter)
+                    {
+                        wrkFile = wrkFile.Replace(badCh, "");
+                    }
+
+                    // ファイル名作成
+                    filePath += @"\" + @wrkFile;
+
+                    // ファイル保存
+                    m_UsedExcel.SaveSwitch = true;
+                    m_UsedExcel.ExcelSaveBook(filePath);
+
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+
+        }
+
+        /// <summary>
+        /// 請求書(表紙)作成
+        /// </summary>
+        /// <returns></returns>
+        private CommonDefine.RetunAnswer PrintCover()
+        {
+            try
+            {
+                // 請求書表紙シートの取得
+                m_UsedExcel.ExcelSheetGet(s_DicSheetName[enumSheetName.Cover]);
+
+                // ページ縦・横セット
+                m_UsedExcel.ExcelFitCountSet(2, 1);
+
+                // ① 施工開始日(4行目 M列)
+                ExcelPrintData startDate = new ExcelPrintData();
+                startDate.AddPrintData("L", 3, m_ConstructionBaseInfo.ConstructionStartingDate.ToString("yyyy年MM月dd日")).ExcelCellSet(m_UsedExcel);
+
+                // ② 施工終了日(5行目 M列)
+                ExcelPrintData endDate = new ExcelPrintData();
+                endDate.AddPrintData("L", 4, m_ConstructionBaseInfo.ConstructionCompletionDate.ToString("yyyy年MM月dd日")).ExcelCellSet(m_UsedExcel);
+
+                // ③ 請求日(7行目 K列)
+                ExcelPrintData reqDate = new ExcelPrintData();
+                reqDate.AddPrintData("K", 6, radioButton4.Checked ? dateTimePicker1.Value.ToString("yyyy年MM月dd日") : "　　年　　月　　日").ExcelCellSet(m_UsedExcel);
+
+                // ④ 請求先名称(9行目 D列)
+                ExcelPrintData nameData = new ExcelPrintData();
+                nameData.AddPrintData("D", 8, m_DicConstructionBaseInfoDetail[m_ConstructionCode][(int)ConstructionBaseInfoDetail.DetailDataNo.OrderersName]).ExcelCellSet(m_UsedExcel);
+
+                // ⑤ 請求金額(14行目 G列)
+                ExcelPrintData priceData = new ExcelPrintData();
+                priceData.AddPrintData("G", 13, m_LstRequestTotalData[m_SelectOrderIndex].BillTotalPrice.ToString("#,#")).ExcelCellSet(m_UsedExcel);
+
+                // ⑥ 消費税(15行目 J列)
+                ExcelPrintData taxData = new ExcelPrintData();
+                taxData.AddPrintData("J", 14, m_LstRequestTotalData[m_SelectOrderIndex].TaxPrice.ToString("#,#")).ExcelCellSet(m_UsedExcel);
+
+                // ⑦ 工事件名(17行目 G列)
+                ExcelPrintData constNameData = new ExcelPrintData();
+                constNameData.AddPrintData("G", 16, m_DicConstructionBaseInfoDetail[m_ConstructionCode][(int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName]).ExcelCellSet(m_UsedExcel);
+
+                return CommonDefine.RetunAnswer.Answer0;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return CommonDefine.RetunAnswer.Answer1;
+            }
+        }
+
+        /// <summary>
+        /// 請求書(内訳)作成
+        /// </summary>
+        /// <param name="dicReqDetail"></param>
+        /// <param name="constLedger"></param>
+        /// <param name="lstConstLink"></param>
+        /// <returns></returns>
+        private CommonDefine.RetunAnswer PrintDetail(Dictionary<int,Dictionary<int,RequestDataDetail>> dicReqDetail, ConstructionLedger constLedger)
+        {
+            try
+            {
+                // 請求書内訳シートの取得
+                m_UsedExcel.ExcelSheetGet(s_DicSheetName[enumSheetName.Detail]);
+
+                // ページ縦・横セット
+                m_UsedExcel.ExcelFitCountSet(2, 1);
+
+                // ------------------------------- 工事名 -------------------------------
+                // ① 工事件名
+                ExcelPrintData constNameData = new ExcelPrintData();
+                constNameData.AddPrintData("C", 2, m_DicConstructionBaseInfoDetail[m_ConstructionCode][(int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName]).ExcelCellSet(m_UsedExcel);
+
+                // ------------------------------- 名称列 -------------------------------
+                ExcelPrintData nameDatas = new ExcelPrintData();
+
+                // 増減工事情報
+                foreach (int childConstCode in m_LstConstructionLink)
+                {
+                    if (m_DicConstructionBaseInfoDetail.ContainsKey(childConstCode))
+                    {
+                        // ⑤ 工事件名
+                        nameDatas.AddPrintData("B", 10 + m_LstConstructionLink.IndexOf(childConstCode), m_DicConstructionBaseInfoDetail[childConstCode][(int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName]);
+                    }
+                }
+                nameDatas.ExcelCellSet(m_UsedExcel);
+
+                // ------------------------------- 仕様列 -------------------------------
+                ExcelPrintData spaceData1 = new ExcelPrintData();
+
+                // 増減工事情報
+                // ６行に満たない場合は、残り行は空白とする
+                for (int i = 0; i < (6 - m_LstConstructionLink.Count); i++)
+                {
+                    spaceData1.AddPrintData("C", 15 - i, "");
+                    spaceData1.AddPrintData("D", 15 - i, "");
+                    spaceData1.AddPrintData("E", 15 - i, "");
+                }
+                spaceData1.ExcelCellSet(m_UsedExcel);
+
+                // ------------------------------- 仕様列 -------------------------------
+                // ⑪ 消費税率
+                ExcelPrintData taxData = new ExcelPrintData();
+                taxData.AddPrintData("C", 24, string.Format("{0}%", CommonMotions.SystemMasterData.ConsumptionTax)).ExcelCellSet(m_UsedExcel);
+
+
+                // ------------------------------- 金額列 -------------------------------
+                // 金額列
+                ExcelPrintData priceData = new ExcelPrintData();
+
+                // ② 請負金額
+                priceData.AddPrintData("G", 5, constLedger.OrdersDecisionPrice);
+
+                // ④ 見積もり金額
+                priceData.AddPrintData("G", 9, dicReqDetail[m_ConstructionCode][m_SelectOrderIndex + 1].BillPrice);
+
+                // 増減工事情報
+                foreach (int childConstCode in m_LstConstructionLink)
+                {
+                    if (dicReqDetail.ContainsKey(childConstCode))
+                    {
+                        // ⑥ 見積金額
+                        priceData.AddPrintData("G", 10 + m_LstConstructionLink.IndexOf(childConstCode), dicReqDetail[childConstCode][m_SelectOrderIndex + 1].BillPrice);
+                    }
+                }
+
+                // ⑦ 今回ご請求分
+                priceData.AddPrintData("G", 17, m_LstRequestTotalData[m_SelectOrderIndex].BillPrice);
+
+                if (dicReqDetail[m_ConstructionCode][m_SelectOrderIndex + 1].AmountBlance != 0)
+                {
+                    // ⑨ 未入金分
+                    priceData.AddPrintData("G", 21, dicReqDetail[m_ConstructionCode][m_SelectOrderIndex + 1].AmountBlance);
+                }
+                else
+                {
+                    // ⑨ 未入金分が０の場合は空白行とする
+                    ExcelPrintData spaceData2 = new ExcelPrintData();
+                    spaceData2.AddPrintData("B", 21, "").ExcelCellSet(m_UsedExcel);
+                }
+
+                // ⑩ 小計
+                int partTotal = m_LstRequestTotalData[m_SelectOrderIndex].BillPrice + m_LstRequestTotalData[m_SelectOrderIndex].AmountBlance;
+                priceData.AddPrintData("G", 23, partTotal);
+
+                // ⑫ 消費税
+                priceData.AddPrintData("G", 24, m_LstRequestTotalData[m_SelectOrderIndex].TaxPrice);
+
+                // ⑬ 税込合計金額
+                priceData.AddPrintData("G", 25, m_LstRequestTotalData[m_SelectOrderIndex].BillTotalPrice);
+
+                // 一括請求時は次を印刷対象外とする
+                if (m_ConstructionBaseInfo.BillingSplitFlg != 0)
+                {
+                    if (m_SelectOrderIndex != 0)
+                    {
+                        // ③ 請求済金額
+                        priceData.AddPrintData("G", 7, m_LstRequestTotalData[m_SelectOrderIndex - 1].PricePaid);
+                    }
+
+                    // ⑧ 請負金額残額
+                    priceData.AddPrintData("G", 19, m_LstRequestTotalData[m_SelectOrderIndex].PriceBalance);
+                }
+                else
+                {
+                    // 一括払いの場合は空白行とする
+                    ExcelPrintData spaceData3 = new ExcelPrintData();
+
+                    // ③ 請求済金額
+                    spaceData3.AddPrintData("B", 7, "");
+                    spaceData3.AddPrintData("C", 7, "");
+                    spaceData3.AddPrintData("D", 7, "");
+                    spaceData3.AddPrintData("E", 7, "");
+                    spaceData3.ExcelCellSet(m_UsedExcel);
+
+                    // ⑧ 請負金額残額
+                    ExcelPrintData spaceData4 = new ExcelPrintData();
+                    spaceData4.AddPrintData("B", 19, "");
+                    spaceData4.AddPrintData("D", 19, "");
+                    spaceData4.AddPrintData("E", 19, "");
+                    spaceData4.ExcelCellSet(m_UsedExcel);
+                }
+
+                priceData.ExcelCellSet(m_UsedExcel);
+
+                return CommonDefine.RetunAnswer.Answer0;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return CommonDefine.RetunAnswer.Answer1;
+            }
+
+        }
+
+        /// <summary>
+        /// Excelデータ出力用内部クラス定義
+        /// </summary>
+        private class ExcelPrintData
+        {
+            // Excelデータ保持用用ディクショナリ
+            private Dictionary<int, Dictionary<int, object>> m_DicPrintData = new Dictionary<int, Dictionary<int, object>>();
+
+            // Excelカラム名取得用
+            private static char[] s_Asc = { 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z' };
+
+            private int m_RowMin = int.MaxValue;
+            private int m_RowMax = int.MinValue;
+            private int m_ColMin = int.MaxValue;
+            private int m_ColMax = int.MinValue;
+
+            /// <summary>
+            /// エクセルカラム名とインデックス番号のディクショナリ
+            /// </summary>
+            private static Dictionary<string, int> s_IndexOfExcelColumn = InitDicColumnIndex();
+
+            /// <summary>
+            /// Excelカラムインデックスディクショナリ作成メソッド
+            /// </summary>
+            /// <returns></returns>
+            private static Dictionary<string, int> InitDicColumnIndex()
+            {
+                var result = new Dictionary<string, int>();
+
+                for (int indx = 0; indx < 256; indx++)
+                {
+                    string res = GetColumnString(indx);
+
+                    result.Add(res, indx);
+
+                }
+                return result;
+            }
+
+            /// <summary>
+            /// カラム英字名を取得
+            /// </summary>
+            /// <param name="colIndex"></param>
+            /// <returns></returns>
+            private static string GetColumnString(int colIndex)
+            {
+                string res = "";
+
+                int court = colIndex;
+                while (court >= s_Asc.Count())
+                {
+                    res = s_Asc[court % s_Asc.Count()] + res;
+                    court = (int)Math.Truncate((double)court / (double)s_Asc.Count() - 1);
+                }
+                res = s_Asc[court % s_Asc.Count()] + res;
+
+                return res;
+            }
+
+            /// <summary>
+            /// データ追加
+            /// </summary>
+            /// <param name="colName">カラム名文字(※ "A", "B", 等...</param>
+            /// <param name="rowNo">行インデックス番号 0オリジン</param>
+            /// <param name="data">出力データオブジェクト</param>
+            /// <returns></returns>
+            public ExcelPrintData AddPrintData(string colName, int rowNo, object data)
+            {
+                return AddPrintData(s_IndexOfExcelColumn[colName], rowNo, data);
+            }
+
+            /// <summary>
+            /// データ追加
+            /// </summary>
+            /// <param name="colIndex">カラムインデックス 0オリジン</param>
+            /// <param name="rowNo">行インデックス番号 0オリジン</param>
+            /// <param name="data">出力データオブジェクト</param>
+            /// <returns></returns>
+            public ExcelPrintData AddPrintData(int colIndex, int rowNo, object data)
+            {
+                if (!m_DicPrintData.ContainsKey(rowNo))
+                    m_DicPrintData[rowNo] = new Dictionary<int, object>();
+
+                m_DicPrintData[rowNo][colIndex] = data;
+
+                if (m_RowMin > rowNo) m_RowMin = rowNo;
+                if (m_RowMax < rowNo) m_RowMax = rowNo;
+                if (m_ColMin > colIndex) m_ColMin = colIndex;
+                if (m_ColMax < colIndex) m_ColMax = colIndex;
+
+                return this;
+            }
+
+            /// <summary>
+            /// UsedExcelオブジェクトにデータをセットする
+            /// </summary>
+            /// <param name="usedExcel">UsedExcelオブジェクト(シート取得済みであること)</param>
+            public void ExcelCellSet(UsedExcel usedExcel)
+            {
+                if (m_RowMin == int.MaxValue ||
+                    m_RowMax == int.MinValue ||
+                    m_ColMin == int.MaxValue ||
+                    m_ColMax == int.MinValue)
+                {
+                    return;
+                }
+
+                // オブジェクト配列を宣言
+                object[,] objCells = new object[m_RowMax - m_RowMin + 1, m_ColMax - m_ColMin + 1];
+
+                // 配列にデータを移し替える
+                foreach (int row in m_DicPrintData.Keys)
+                {
+                    foreach (int col in m_DicPrintData[row].Keys)
+                    {
+                        objCells[row - m_RowMin, col - m_ColMin] = m_DicPrintData[row][col];
+                    }
+                }
+
+                // セル名を取得
+                string startCell = GetColumnString(m_ColMin) + string.Format("{0}", m_RowMin + 1);
+                string endCell = GetColumnString(m_ColMax) + string.Format("{0}", m_RowMax + 1);
+
+                // セルにセット
+                usedExcel.ExcelCellSet(startCell, objCells, endCell);
+
+            }
+        }
+
+    }
+}
